package ru.dbotthepony.mc.otm;

import net.minecraft.MethodsReturnNonnullByDefault;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.CreativeModeTab;
import net.minecraft.world.item.ItemStack;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.fml.ModList;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.event.lifecycle.FMLClientSetupEvent;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraftforge.fml.javafmlmod.FMLJavaModLoadingContext;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import ru.dbotthepony.mc.otm.block.entity.blackhole.ExplosionQueue;
import ru.dbotthepony.mc.otm.capability.MatteryCapability;
import ru.dbotthepony.mc.otm.capability.android.AndroidCapability;
import ru.dbotthepony.mc.otm.capability.android.AndroidCapabilityPlayer;
import ru.dbotthepony.mc.otm.capability.drive.DrivePool;
import ru.dbotthepony.mc.otm.client.AndroidGui;
import ru.dbotthepony.mc.otm.client.EventHandler;
import ru.dbotthepony.mc.otm.client.model.GravitationStabilizerModel;
import ru.dbotthepony.mc.otm.client.model.TritaniumArmorModel;
import ru.dbotthepony.mc.otm.compat.mekanism.QIOKt;
import ru.dbotthepony.mc.otm.core.ImpreciseFraction;
import ru.dbotthepony.mc.otm.item.weapon.AbstractWeaponItem;
import ru.dbotthepony.mc.otm.item.PortableCondensationDriveItem;
import ru.dbotthepony.mc.otm.matter.MatterDataKt;
import ru.dbotthepony.mc.otm.matter.MatterRegistryKt;
import ru.dbotthepony.mc.otm.network.MatteryNetworking;
import ru.dbotthepony.mc.otm.registry.*;
import ru.dbotthepony.mc.otm.storage.*;

import javax.annotation.ParametersAreNonnullByDefault;

// The value here should match an entry in the META-INF/mods.toml file
@Mod(OverdriveThatMatters.MOD_ID)
@ParametersAreNonnullByDefault
@MethodsReturnNonnullByDefault
public final class OverdriveThatMatters {
	// Directly reference a log4j logger.
	public static final String MOD_ID = "overdrive_that_matters";
	public static final Logger LOGGER = LogManager.getLogger();

	public static OverdriveThatMatters INSTANCE;
	public AndroidGui ANDROID_GUI;
	private StorageStackType<ItemStackWrapper> ITEM_STORAGE;

	public StorageStackType<ItemStackWrapper> ITEM_STORAGE() {
		return ITEM_STORAGE;
	}

	public static ResourceLocation loc(String path) {
		return new ResourceLocation(MOD_ID, path);
	}

	public final CreativeModeTab CREATIVE_TAB = new CreativeModeTab("otm") {
		@Override
		public ItemStack makeIcon() {
			return new ItemStack(MItems.INSTANCE.getBATTERY_CREATIVE(), 1);
		}
	};

	public OverdriveThatMatters() {
		if (INSTANCE != null) {
			throw new IllegalStateException("yo what the fuck");
		}

		INSTANCE = this;

		MRegistry.INSTANCE.initialize(FMLJavaModLoadingContext.get());

		FMLJavaModLoadingContext.get().getModEventBus().addListener(this::setup);
		FMLJavaModLoadingContext.get().getModEventBus().addListener(this::setupClient);

		// Register ourselves for server and other game events we are interested in
		MinecraftForge.EVENT_BUS.register(this);
		MinecraftForge.EVENT_BUS.register(TickerKt.class);
		MinecraftForge.EVENT_BUS.register(AndroidCapabilityPlayer.Companion);
		MinecraftForge.EVENT_BUS.register(AndroidCapability.Companion);
		MinecraftForge.EVENT_BUS.register(MatterRegistryKt.class);
		MinecraftForge.EVENT_BUS.register(MatterDataKt.class);
		MinecraftForge.EVENT_BUS.register(ExplosionQueue.Companion);
		MinecraftForge.EVENT_BUS.register(AbstractWeaponItem.Companion);

		FMLJavaModLoadingContext.get().getModEventBus().register(MatteryCapability.class);

		FMLJavaModLoadingContext.get().getModEventBus().register(MRecipes.class);

		MinecraftForge.EVENT_BUS.register(DrivePool.INSTANCE);
		MinecraftForge.EVENT_BUS.register(PortableCondensationDriveItem.Companion);

		FMLJavaModLoadingContext.get().getModEventBus().addListener(AndroidCapability::registerEffects);
	}

	private void setup(final FMLCommonSetupEvent event) {
		MatteryNetworking.register();
		ITEM_STORAGE = StorageRegistry.register(ItemStackWrapper.class, ItemStackWrapper.EMPTY, new ImpreciseFraction("3.125"), false);

		if (ModList.get().isLoaded("mekanism")) {
			MinecraftForge.EVENT_BUS.register(QIOKt.class);
		}
	}

	private void setupClient(final FMLClientSetupEvent event) {
		ANDROID_GUI = new AndroidGui();
		MinecraftForge.EVENT_BUS.register(ANDROID_GUI);
		MinecraftForge.EVENT_BUS.register(AndroidGui.class);
		MinecraftForge.EVENT_BUS.register(EventHandler.class);

		TritaniumArmorModel.register();
		GravitationStabilizerModel.register();
	}
}
