package ru.dbotthepony.mc.otm.client;

import net.minecraftforge.client.event.MovementInputUpdateEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import ru.dbotthepony.mc.otm.capability.android.AndroidCapabilityPlayer;
import ru.dbotthepony.mc.otm.capability.MatteryCapability;
import ru.dbotthepony.mc.otm.registry.AndroidFeatures;

public class EventHandler {
	@SubscribeEvent
	public static void inputEvent(MovementInputUpdateEvent event) {
		var ply = event.getPlayer();
		var input = event.getInput();

		ply.getCapability(MatteryCapability.ANDROID).ifPresent(_cap -> {
			if (!(_cap instanceof AndroidCapabilityPlayer cap))
				return;

			if (cap.hasFeature(AndroidFeatures.INSTANCE.getAIR_BAGS()))
				return;

			if (ply.getAbilities().mayfly) {
				cap.last_jump_ticks = 14;
			} else {
				if (ply.isInWater()) {
					if (ply.isOnGround()) {
						cap.last_jump_ticks = 14;
					}

					if (ply.isSwimming()) {
						ply.setSwimming(false);
					}

					if (cap.last_jump_ticks <= 0) {
						event.getInput().jumping = false;
						event.getInput().up = false;
					} else {
						cap.last_jump_ticks--;
					}
				}
			}
		});
	}
}
