package ru.dbotthepony.mc.otm.registry;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.crafting.Recipe;
import net.minecraft.world.item.crafting.RecipeSerializer;
import net.minecraft.world.item.crafting.RecipeType;
import net.minecraftforge.event.RegistryEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import ru.dbotthepony.mc.otm.OverdriveThatMatters;
import ru.dbotthepony.mc.otm.recipe.PlatePressRecipe;
import ru.dbotthepony.mc.otm.recipe.PlatePressRecipeFactory;

public class MRecipes {
	public static class MatteryRecipeType<T extends Recipe<?>> implements RecipeType<T> {
		public final ResourceLocation name;

		private MatteryRecipeType(ResourceLocation name) {
			this.name = name;
		}

		private void register() {
			net.minecraft.core.Registry.register(net.minecraft.core.Registry.RECIPE_TYPE, name, this);
		}

		@Override
		public String toString() {
			return name.toString();
		}
	}

	public static final MatteryRecipeType<PlatePressRecipe> PLATE_PRESS = new MatteryRecipeType<>(OverdriveThatMatters.loc(MNames.PLATE_PRESS));

	@SubscribeEvent
	@SuppressWarnings("unused")
	public static void register(final FMLCommonSetupEvent event) {
		PLATE_PRESS.register();
	}

	@SubscribeEvent
	@SuppressWarnings("unused")
	public static void register(final RegistryEvent.Register<RecipeSerializer<?>> event) {
		event.getRegistry().register(PlatePressRecipeFactory.INSTANCE);
	}
}
