package ru.dbotthepony.mc.otm.block

import net.minecraft.core.BlockPos
import net.minecraft.core.Direction
import net.minecraft.world.item.context.BlockPlaceContext
import net.minecraft.world.level.BlockGetter
import net.minecraft.world.level.block.Block
import net.minecraft.world.level.block.EntityBlock
import net.minecraft.world.level.block.entity.BlockEntity
import net.minecraft.world.level.block.state.BlockState
import net.minecraft.world.level.block.state.StateDefinition
import net.minecraft.world.phys.shapes.CollisionContext
import net.minecraft.world.phys.shapes.VoxelShape
import ru.dbotthepony.mc.otm.block.entity.MatterCapacitorBankBlockEntity
import ru.dbotthepony.mc.otm.shapes.BlockShapes

class MatterCapacitorBankBlock : RotatableMatteryBlock(), EntityBlock {
	override fun newBlockEntity(blockPos: BlockPos, blockState: BlockState): BlockEntity {
		return MatterCapacitorBankBlockEntity(blockPos, blockState)
	}

	override fun getStateForPlacement(context: BlockPlaceContext): BlockState? {
		var state = super.getStateForPlacement(context) ?: return null

		for (prop in BatteryBankBlock.BATTERY_SLOTS_PROPS)
			state = state.setValue(prop, false)

		return state
	}

	override fun createBlockStateDefinition(builder: StateDefinition.Builder<Block, BlockState>) {
		builder.add(*BatteryBankBlock.BATTERY_SLOTS_PROPS)
		super.createBlockStateDefinition(builder)
	}

	override fun getShape(
		p_60555_: BlockState,
		p_60556_: BlockGetter,
		p_60557_: BlockPos,
		p_60558_: CollisionContext
	): VoxelShape {
		return SHAPES[p_60555_.getValue(FACING).ordinal]
	}

	companion object {
		private val SHAPES: List<VoxelShape>

		init {
			val def = BlockShapes.BATTERY_BANK.computeShape()

			SHAPES = listOf(
				def,
				def,
				def,
				BlockShapes.BATTERY_BANK.rotate(Direction.NORTH).computeShape(),
				BlockShapes.BATTERY_BANK.rotate(Direction.WEST).computeShape(),
				BlockShapes.BATTERY_BANK.rotate(Direction.EAST).computeShape()
			)
		}
	}
}