package ru.dbotthepony.mc.otm.client.screen

import net.minecraft.network.chat.Component
import net.minecraft.network.chat.TranslatableComponent
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.client.screen.panels.*
import ru.dbotthepony.mc.otm.menu.EnergyCounterMenu
import ru.dbotthepony.mc.otm.menu.FormattingHelper

class EnergyCounterScreen(menu: EnergyCounterMenu, inventory: Inventory, title: Component) : MatteryScreen<EnergyCounterMenu>(menu, inventory, title) {
	override fun makeMainFrame(): FramePanel {
		val frame = super.makeMainFrame()!!

		var label: Label = object : Label(this@EnergyCounterScreen, frame) {
			override fun tick() {
				super.tick()
				text = TranslatableComponent(
					"otm.item.power.passed",
					FormattingHelper.formatPower(menu.passed.value)
				)
			}
		}

		label.dock = Dock.TOP
		label.setDockMargin(4f, 0f, 0f, 0f)

		label = object : Label(this@EnergyCounterScreen, frame) {
			override fun tick() {
				super.tick()
				text = TranslatableComponent(
					"otm.item.power.average",
					FormattingHelper.formatPower(menu.average.value)
				)
			}
		}

		label.dock = Dock.TOP
		label.setDockMargin(4f, 0f, 0f, 0f)

		label = object : Label(this@EnergyCounterScreen, frame) {
			override fun tick() {
				super.tick()
				text = TranslatableComponent(
					"otm.item.power.last_20_ticks",
					FormattingHelper.formatPower(menu.last20Ticks.value)
				)
			}
		}

		label.dock = Dock.TOP
		label.setDockMargin(4f, 0f, 0f, 0f)

		label = object : Label(this@EnergyCounterScreen, frame) {
			override fun tick() {
				super.tick()
				text = TranslatableComponent(
					"otm.item.power.last_tick",
					FormattingHelper.formatPower(menu.lastTick.value)
				)
			}
		}

		label.dock = Dock.TOP
		label.setDockMargin(4f, 0f, 0f, 0f)

		label = object : Label(this@EnergyCounterScreen, frame) {
			override fun tick() {
				super.tick()

				text = TranslatableComponent(
					"block.overdrive_that_matters.energy_counter.facing",
					menu.inputDirection.value
				)
			}
		}

		label.dock = Dock.TOP
		label.setDockMargin(4f, 0f, 0f, 0f)

		val button = ButtonPanel(this, frame, 0f, 0f, 0f, 20f, TranslatableComponent("block.overdrive_that_matters.energy_counter.switch"))
		button.dock = Dock.TOP
		button.setDockMargin(4f, 0f, 4f, 0f)
		button.bind { menu.switchDirection.userInput() }

		val infoPanels = frame.fetchChildren()

		label = Label(this, frame, TranslatableComponent("block.overdrive_that_matters.energy_counter.limit"))
		label.dock = Dock.TOP
		label.setDockMargin(4f, 0f, 0f, 0f)

		val inputPanel = NumberInputPanel(this, frame, menu.maxIO)
		inputPanel.dock = Dock.TOP
		inputPanel.setDockMargin(4f, 0f, 4f, 0f)

		val limitsPanels = frame.fetchChildren().filter { !infoPanels.contains(it) }

		val informationTab = frame.addTab(FramePanel.Position.TOP)
		val limitsTab = frame.addTab(FramePanel.Position.TOP)

		informationTab.showHidePanels(infoPanels)
		limitsTab.showHidePanels(limitsPanels)

		limitsTab.onClose!!.run()

		return frame
	}
}