package ru.dbotthepony.mc.otm.client.screen.panels

import net.minecraft.client.gui.components.Button
import net.minecraft.client.gui.components.Button.OnPress
import net.minecraft.network.chat.Component
import ru.dbotthepony.mc.otm.client.screen.MatteryScreen

open class ButtonPanel(
	screen: MatteryScreen<*>,
	parent: EditablePanel?,
	x: Float = 0f,
	y: Float = 0f,
	width: Float = 40f,
	height: Float = 20f,
	label: Component
) : MinecraftWidgetPanel<Button>(screen, parent, x, y, width, height) {
	constructor(screen: MatteryScreen<*>, parent: EditablePanel?, label: Component) : this(screen, parent, x = 0f, label = label)

	var label = label
		set(value) {
			field = value
			widget?.message = value
		}

	override fun copyValues(new_widget: Button, old_widget: Button) {}
	override fun configureNew(widget: Button, recreation: Boolean) {}

	override fun makeNew(): Button {
		return object : Button(0, 0, width.toInt(), height.toInt().coerceAtMost(20), label, OnPress { this@ButtonPanel.onPress() }) {
			override fun isHoveredOrFocused(): Boolean {
				return this@ButtonPanel.isHovered
			}
		}
	}

	protected var callback: Runnable? = null

	fun bind(runnable: Runnable) {
		callback = runnable
	}

	protected open fun onPress() {
		callback?.run()
	}
}