package ru.dbotthepony.mc.otm.item

import net.minecraft.client.model.HumanoidModel
import net.minecraft.sounds.SoundEvent
import net.minecraft.world.entity.EquipmentSlot
import net.minecraft.world.entity.LivingEntity
import net.minecraft.world.item.*
import net.minecraft.world.item.crafting.Ingredient
import net.minecraftforge.client.IItemRenderProperties
import ru.dbotthepony.mc.otm.OverdriveThatMatters
import ru.dbotthepony.mc.otm.client.model.GravitationStabilizerModel
import java.util.function.Consumer

private object GravitationStabilizerArmorMaterial : ArmorMaterial {
	override fun getDurabilityForSlot(p_40410_: EquipmentSlot) = 0
	override fun getDefenseForSlot(p_40411_: EquipmentSlot) = 3
	override fun getEnchantmentValue() = 0
	override fun getEquipSound(): SoundEvent? = null
	override fun getRepairIngredient(): Ingredient = Ingredient.EMPTY

	const val ID = "${OverdriveThatMatters.MOD_ID}:gravitation_stabilizer"

	override fun getName(): String = ID
	override fun getToughness() = 0f
	override fun getKnockbackResistance() = 0f
}

private object GravitationStabilizerArmorRenderProperties : IItemRenderProperties {
	override fun getArmorModel(
		entityLiving: LivingEntity,
		itemStack: ItemStack,
		armorSlot: EquipmentSlot,
		_default: HumanoidModel<*>
	): HumanoidModel<*> {
		return GravitationStabilizerModel.getModel()
	}
}

class ItemPortableGravitationStabilizer : ArmorItem(GravitationStabilizerArmorMaterial, EquipmentSlot.CHEST, Properties().stacksTo(1).rarity(Rarity.RARE).tab(OverdriveThatMatters.INSTANCE.CREATIVE_TAB)) {
	override fun initializeClient(consumer: Consumer<IItemRenderProperties>) {
		super.initializeClient(consumer)
		consumer.accept(GravitationStabilizerArmorRenderProperties)
	}
}
