package ru.dbotthepony.mc.otm.item.weapon

import net.minecraft.world.entity.player.Player
import net.minecraft.world.entity.projectile.Arrow
import net.minecraft.world.item.ItemStack
import ru.dbotthepony.kvector.vector.Angle3f
import ru.dbotthepony.kvector.vector.ndouble.Vector3d
import ru.dbotthepony.mc.otm.core.ImpreciseFraction
import ru.dbotthepony.mc.otm.entity.PlasmaProjectile
import ru.dbotthepony.mc.otm.position

class PlasmaRifleItem : PlasmaWeaponItem<WeaponDataTable>(WeaponDataTable::class, ImpreciseFraction(200_000)) {
	override val roundsPerMinute: Int = 400
	override val scopingTime: Int = 7
	override val positionIdle: Vector3d
		get() = Vector3d(0.2,-0.4,-0.6)
	override val positionIronSights: Vector3d
		get() = Vector3d(0.0,-0.24,-1.0)
	override val rotIdle: Angle3f
		get() = Angle3f(0f,-0.02f,0f)
	override val rotIronSights: Angle3f
		get() = Angle3f(-0.02f,0f,0f)

	override fun primaryFire(itemStack: ItemStack, player: Player, dt: WeaponDataTable): Boolean {
		println("FIER! ${Thread.currentThread()}")

		if (!player.level.isClientSide) {
			val arrow = Arrow(player.level, player)

			arrow.shootFromRotation(player, player.xRot, player.yRot, 0f, 2f, 0f)

			player.level.addFreshEntity(arrow)

			//val arrow = PlasmaProjectile(player.level)
			//arrow.position = player.position
			//player.level.addFreshEntity(arrow)
		}

		return true
	}

	companion object {
		private val ENERGY_PER_SHOT = ImpreciseFraction(3_000)
	}
}
