package ru.dbotthepony.mc.otm.menu

import net.minecraft.world.SimpleContainer
import net.minecraft.world.entity.player.Inventory
import net.minecraft.world.item.ItemStack
import ru.dbotthepony.mc.otm.block.entity.MatterRecyclerBlockEntity
import ru.dbotthepony.mc.otm.item.MatterDustItem
import ru.dbotthepony.mc.otm.menu.widget.LevelGaugeWidget
import ru.dbotthepony.mc.otm.menu.widget.ProgressGaugeWidget
import ru.dbotthepony.mc.otm.registry.MMenus

class MatterRecyclerMenu @JvmOverloads constructor(
	containerID: Int,
	inventory: Inventory,
	tile: MatterRecyclerBlockEntity? = null
) : MatteryPoweredMenu(MMenus.MATTER_RECYCLER, containerID, inventory, tile) {
	val input: MatterySlot
	val progress: ProgressGaugeWidget
	val matter = LevelGaugeWidget(this, tile?.matter)

	init {
		val container = tile?.container ?: SimpleContainer(1)

		input = object : MatterySlot(container, 0) {
			override fun mayPlace(p_40231_: ItemStack): Boolean {
				return p_40231_.item is MatterDustItem && (p_40231_.item as MatterDustItem).getMatterValue(p_40231_) != null
			}
		}

		if (tile == null) {
			progress = ProgressGaugeWidget(this)
		} else {
			progress = ProgressGaugeWidget(this, tile::workProgress, tile::isUnableToProcess)
		}

		addSlot(input)
		addInventorySlots()
	}

	override fun getWorkingSlotStart(): Int {
		return 0
	}

	override fun getWorkingSlotEnd(): Int {
		return 2
	}
}
