package ru.dbotthepony.mc.otm.menu

import kotlin.jvm.JvmOverloads
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.block.entity.MatterReplicatorBlockEntity
import ru.dbotthepony.mc.otm.menu.widget.LevelGaugeWidget
import ru.dbotthepony.mc.otm.menu.widget.ProgressGaugeWidget
import net.minecraft.world.SimpleContainer
import ru.dbotthepony.mc.otm.registry.MMenus

class MatterReplicatorMenu @JvmOverloads constructor(
	p_38852_: Int,
	inventory: Inventory,
	tile: MatterReplicatorBlockEntity? = null
) : MatteryPoweredMenu(
	MMenus.MATTER_REPLICATOR, p_38852_, inventory, tile
) {
	val matter: LevelGaugeWidget
	val progress: ProgressGaugeWidget
	val outputSlots: Array<MachineOutputSlot>

	init {
		val container = tile?.container ?: SimpleContainer(5)

		outputSlots = Array(5) {
			val slot = MachineOutputSlot(container, it)
			addSlot(slot)
			return@Array slot
		}

		if (tile != null) {
			matter = LevelGaugeWidget(this, tile.matter)
			progress = ProgressGaugeWidget(this, tile::workProgress, tile::isUnableToProcess)
		} else {
			matter = LevelGaugeWidget(this)
			progress = ProgressGaugeWidget(this)
		}

		addInventorySlots()
	}

	override fun getWorkingSlotStart(): Int {
		return 0
	}

	override fun getWorkingSlotEnd(): Int {
		return 5
	}
}