package ru.dbotthepony.mc.otm.menu

import net.minecraft.world.SimpleContainer
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.block.entity.PatternStorageBlockEntity
import ru.dbotthepony.mc.otm.core.ImpreciseFraction
import ru.dbotthepony.mc.otm.graph.matter.MatterNetworkGraph
import ru.dbotthepony.mc.otm.menu.widget.LevelGaugeWidget
import ru.dbotthepony.mc.otm.registry.MMenus

class PatternStorageMenu @JvmOverloads constructor(
	p_38852_: Int,
	inventory: Inventory?,
	tile: PatternStorageBlockEntity? = null
) : MatteryMenu(
	MMenus.PATTERN_STORAGE, p_38852_, inventory!!, tile
) {
	val pattern_slots = arrayOfNulls<PatternSlot>(2 * 4)
	val stored_this: LevelGaugeWidget
	val stored_grid: LevelGaugeWidget

	init {
		if (tile == null) {
			stored_this = LevelGaugeWidget(this)
			stored_grid = LevelGaugeWidget(this)
		} else {
			stored_this = LevelGaugeWidget(this, tile)
			stored_grid = LevelGaugeWidget(this, {
				ImpreciseFraction((tile.getAsMatterNode().graph as MatterNetworkGraph?)?.getPatternCount() ?: 0)
			}, {
				ImpreciseFraction((tile.getAsMatterNode().graph as MatterNetworkGraph?)?.getPatternCapacity() ?: 0)
			})
		}

		val patterns = tile?.patterns ?: SimpleContainer(2 * 4)

		for (row in 0..1) {
			for (column in 0..3) {
				pattern_slots[row * 4 + column] = PatternSlot(patterns, row * 4 + column, 48 + column * 20, 27 + row * 24)
				addSlot(pattern_slots[row * 4 + column]!!)
			}
		}

		addInventorySlots()
	}

	override fun getWorkingSlotStart(): Int {
		return 0
	}

	override fun getWorkingSlotEnd(): Int {
		return 2 * 4
	}
}