package ru.dbotthepony.mc.otm.menu.data

import org.apache.logging.log4j.LogManager
import java.math.BigDecimal
import java.math.BigInteger

class BigDecimalDataContainer(bytes: Int = 128) : ComplexDataContainer<BigDecimal>(bytes) {
	companion object {
		private val LOGGER = LogManager.getLogger()
	}

	private var _value = BigDecimal.ZERO
	private var mute = false

	override var value: BigDecimal
		get() = _value
		set(value) {
			if (value == _value)
				return

			try {
				buffer.array().fill(0)
				buffer.position(0)
				buffer.putInt(value.scale())
				val bytes = value.unscaledValue().toByteArray()

				buffer.putInt(bytes.size)

				bytes.copyInto(buffer.array(), destinationOffset = 8)

				dirty = true
			} catch(err: Throwable) {
				if (!mute) {
					LOGGER.error("Unable to serialize value $value for network transportation", err)
					mute = true
				}

				buffer.array().fill(0)
			}
		}

	override fun construct() {
		val scale = buffer.position(0).int
		val length = buffer.int
		val bytes = buffer.array().copyOfRange(8, 8 + length)
		_value = BigDecimal(BigInteger(bytes), scale)
	}
}
