package ru.dbotthepony.mc.otm.menu.data

import net.minecraft.world.inventory.ContainerData
import org.apache.logging.log4j.LogManager
import ru.dbotthepony.mc.otm.core.Fraction
import ru.dbotthepony.mc.otm.core.ImpreciseFraction
import ru.dbotthepony.mc.otm.network.NetworkHelper
import java.util.zip.CRC32

class FractionDataContainer : ComplexDataContainer<Fraction>(128) {
	companion object {
		private val LOGGER = LogManager.getLogger()
	}

	private var _value = Fraction.ZERO
	private var mute = false

	override var value: Fraction
		get() = _value
		set(value) {
			if (_value == value)
				return

			_value = value

			try {
				buffer.array().fill(0)
				value.toByteArray().copyInto(buffer.position(0).array())
				dirty = true
			} catch(err: Throwable) {
				if (!mute) {
					LOGGER.error("Unable to serialize value $value for network transportation", err)
					mute = true
				}

				buffer.array().fill(0)
			}
		}

	override fun construct() {
		_value = Fraction.fromByteArray(buffer.array())
	}
}

class ImpreciseFractionDataContainer : ComplexDataContainer<ImpreciseFraction>(128) {
	companion object {
		private val LOGGER = LogManager.getLogger()
	}

	private var _value = ImpreciseFraction.ZERO
	private var mute = false

	override var value: ImpreciseFraction
		get() = _value
		set(value) {
			if (_value == value)
				return

			_value = value

			try {
				buffer.array().fill(0)
				value.toByteArray().copyInto(buffer.position(0).array())
				dirty = true
			} catch(err: Throwable) {
				if (!mute) {
					LOGGER.error("Unable to serialize value $value for network transportation", err)
					mute = true
				}

				buffer.array().fill(0)
			}
		}

	override fun construct() {
		_value = ImpreciseFraction.fromByteArray(buffer.array())
	}
}
