package ru.dbotthepony.mc.otm.menu.data

import net.minecraft.world.inventory.ContainerData

class BooleanDataContainer : ContainerData {
	val buffer = intArrayOf(0)

	var value: Boolean
		get() = buffer[0] > 0
		set(value) { buffer[0] = if (value) 1 else 0 }

	override fun get(p_39284_: Int): Int {
		return buffer[p_39284_]
	}

	override fun set(p_39285_: Int, p_39286_: Int) {
		buffer[p_39285_] = p_39286_
	}

	override fun getCount(): Int {
		return 1
	}
}

class ShortDataContainer : ContainerData {
	val buffer = intArrayOf(0)

	var value: Short
		get() = buffer[0].toShort()
		set(value) { buffer[0] = value.toInt() }

	override fun get(p_39284_: Int): Int {
		return buffer[p_39284_]
	}

	override fun set(p_39285_: Int, p_39286_: Int) {
		buffer[p_39285_] = p_39286_
	}

	override fun getCount(): Int {
		return 1
	}
}

class ByteDataContainer : ContainerData {
	val buffer = intArrayOf(0)

	var value: Byte
		get() = buffer[0].toByte()
		set(value) { buffer[0] = value.toInt() }

	override fun get(p_39284_: Int): Int {
		return buffer[p_39284_]
	}

	override fun set(p_39285_: Int, p_39286_: Int) {
		buffer[p_39285_] = p_39286_
	}

	override fun getCount(): Int {
		return 1
	}
}

class IntDataContainer : MultiByteDataContainer(4) {
	var value: Int
		get() {
			return buffer.position(0).int
		}
		set(value) {
			buffer.position(0).putInt(value)
			dirty = true
		}
}

class FloatDataContainer : MultiByteDataContainer(4) {
	var value: Float
		get() {
			return buffer.position(0).float
		}
		set(value) {
			buffer.position(0).putFloat(value)
			dirty = true
		}
}

class LongDataContainer : MultiByteDataContainer(8) {
	var value: Long
		get() {
			return buffer.position(0).long
		}
		set(value) {
			buffer.position(0).putLong(value)
			dirty = true
		}
}

class DoubleDataContainer : MultiByteDataContainer(8) {
	var value: Double
		get() {
			return buffer.position(0).double
		}
		set(value) {
			buffer.position(0).putDouble(value)
			dirty = true
		}
}
