package ru.dbotthepony.mc.otm.menu.widget

import net.minecraft.network.FriendlyByteBuf
import net.minecraftforge.network.NetworkEvent
import ru.dbotthepony.mc.otm.menu.MatteryMenu
import ru.dbotthepony.mc.otm.network.MatteryNetworking
import java.util.function.Supplier

class OneWayPlayerInputPacket(val id: Int) {
	fun play(context: Supplier<NetworkEvent.Context>) {
		context.get().packetHandled = true

		context.get().enqueueWork {
			((context.get().sender?.containerMenu as? MatteryMenu)?.getWidget(id) as? OneWayPlayerInputWidget)?.userInput()
		}
	}

	fun write(buff: FriendlyByteBuf) {
		buff.writeInt(id)
	}

	companion object {
		fun read(buff: FriendlyByteBuf): OneWayPlayerInputPacket {
			return OneWayPlayerInputPacket(buff.readInt())
		}
	}
}

class OneWayPlayerInputWidget(menu: MatteryMenu, clicker: (() -> Unit)? = null) : AbstractWidget(menu) {
	val clicker: () -> Unit

	init {
		if (clicker != null) {
			this.clicker = clicker
		} else {
			this.clicker = { MatteryNetworking.CHANNEL.sendToServer(OneWayPlayerInputPacket(slotID)) }
		}
	}

	fun userInput() {
		clicker.invoke()
	}

	override fun updateServer() {}
}
