
@file:Suppress("unused")

package ru.dbotthepony.mc.otm.registry

import net.minecraft.network.chat.TextComponent
import net.minecraft.network.chat.TranslatableComponent
import net.minecraft.resources.ResourceLocation
import net.minecraftforge.fml.javafmlmod.FMLJavaModLoadingContext
import net.minecraftforge.registries.DeferredRegister
import net.minecraftforge.registries.RegistryObject
import ru.dbotthepony.mc.otm.OverdriveThatMatters
import ru.dbotthepony.mc.otm.android.AndroidResearchBuilder
import ru.dbotthepony.mc.otm.android.AndroidResearchType
import ru.dbotthepony.mc.otm.android.feature.NanobotsArmor
import ru.dbotthepony.mc.otm.client.render.SkinElement

object AndroidResearch {
	val ICONS = ResourceLocation(OverdriveThatMatters.MOD_ID, "textures/gui/android_upgrades.png")
	val ICON_TRANSFER: SkinElement
	val ICON_ATTACK_BOOST: SkinElement
	val ICON_PLASMA_SHIELD_BOOST: SkinElement
	val ICON_CLOAK: SkinElement
	val ICON_GRAVITATIONAL_STABILIZER: SkinElement
	val ICON_AIR_BAGS: SkinElement
	val ICON_JUMP_BOOST: SkinElement

	val ICON_FEATHER_FALLING: SkinElement
	val ICON_ARC: SkinElement
	val ICON_ARROW: SkinElement
	val ICON_ARMOR: SkinElement
	val ICON_NANOBOTS: SkinElement
	val ICON_NIGHT_VISION: SkinElement
	val ICON_OXYGEN_SUPPLY: SkinElement

	val ICON_PLASMA_SHIELD: SkinElement
	val ICON_SHOCKWAVE: SkinElement
	val ICON_LIMB_OVERCLOCKING: SkinElement
	val ICON_STEP_ASSIST: SkinElement
	val ICON_ENDER_TELEPORT: SkinElement
	val ICON_WIRELESS_CHARGING: SkinElement
	val ICON_UNKNOWN: SkinElement

	val ICON_EXTENDED_REACH: SkinElement

	init {
		var x = 0f
		var y = 0f

		ICON_TRANSFER = SkinElement(ICONS, x, y, 18f, 18f, 126f, 126f)
		x += 18f
		ICON_ATTACK_BOOST = SkinElement(ICONS, x, y, 18f, 18f, 126f, 126f)
		x += 18f
		ICON_PLASMA_SHIELD_BOOST = SkinElement(ICONS, x, y, 18f, 18f, 126f, 126f)
		x += 18f
		ICON_CLOAK = SkinElement(ICONS, x, y, 18f, 18f, 126f, 126f)
		x += 18f
		ICON_GRAVITATIONAL_STABILIZER = SkinElement(ICONS, x, y, 18f, 18f, 126f, 126f)
		x += 18f
		ICON_AIR_BAGS = SkinElement(ICONS, x, y, 18f, 18f, 126f, 126f)
		x += 18f
		ICON_JUMP_BOOST = SkinElement(ICONS, x, y, 18f, 18f, 126f, 126f)

		y += 18f
		x = 0f

		ICON_FEATHER_FALLING = SkinElement(ICONS, x, y, 18f, 18f, 126f, 126f)
		x += 18f
		ICON_ARC = SkinElement(ICONS, x, y, 18f, 18f, 126f, 126f)
		x += 18f
		ICON_ARROW = SkinElement(ICONS, x, y, 18f, 18f, 126f, 126f)
		x += 18f
		ICON_ARMOR = SkinElement(ICONS, x, y, 18f, 18f, 126f, 126f)
		x += 18f
		ICON_NANOBOTS = SkinElement(ICONS, x, y, 18f, 18f, 126f, 126f)
		x += 18f
		ICON_NIGHT_VISION = SkinElement(ICONS, x, y, 18f, 18f, 126f, 126f)
		x += 18f
		ICON_OXYGEN_SUPPLY = SkinElement(ICONS, x, y, 18f, 18f, 126f, 126f)

		y += 18
		x = 0f

		ICON_PLASMA_SHIELD = SkinElement(ICONS, x, y, 18f, 18f, 126f, 126f)
		x += 18f
		ICON_SHOCKWAVE = SkinElement(ICONS, x, y, 18f, 18f, 126f, 126f)
		x += 18f
		ICON_LIMB_OVERCLOCKING = SkinElement(ICONS, x, y, 18f, 18f, 126f, 126f)
		x += 18f
		ICON_STEP_ASSIST = SkinElement(ICONS, x, y, 18f, 18f, 126f, 126f)
		x += 18f
		ICON_ENDER_TELEPORT = SkinElement(ICONS, x, y, 18f, 18f, 126f, 126f)
		x += 18f
		ICON_WIRELESS_CHARGING = SkinElement(ICONS, x, y, 18f, 18f, 126f, 126f)
		x += 18f
		ICON_UNKNOWN = SkinElement(ICONS, x, y, 18f, 18f, 126f, 126f)

		y += 18f
		x = 0f

		ICON_EXTENDED_REACH = SkinElement(ICONS, x, y, 18f, 18f, 126f, 126f)
		x += 18f
	}

	private val registry = DeferredRegister.create(AndroidResearchType::class.java, OverdriveThatMatters.MOD_ID)

	internal fun register() {
		registry.register(FMLJavaModLoadingContext.get().modEventBus)
	}

	val AIR_BAGS: AndroidResearchType<*> by registry.register(MNames.AIR_BAGS) {
		AndroidResearchBuilder()
			.setExperienceCost(18)
			.addFeatureResult(AndroidFeatures.AIR_BAGS)
			.withDescription()
			.withIcon(ICON_AIR_BAGS)
			.build()
	}

	val EXTENDED_REACH: AndroidResearchType<*> by registry.register(MNames.EXTENDED_REACH) {
		AndroidResearchBuilder()
			.setExperienceCost(40)
			.addFeatureResult(AndroidFeatures.EXTENDED_REACH)
			.withDescription()
			.withIcon(ICON_EXTENDED_REACH)
			.build()
	}

	val NANOBOTS: AndroidResearchType<*> by registry.register(MNames.NANOBOTS) {
		AndroidResearchBuilder()
			.setExperienceCost(15)
			.withDescription()
			.withIcon(ICON_NANOBOTS)
			.build()
	}

	val NANOBOTS_ARMOR: AndroidResearchType<*> by registry.register(MNames.NANOBOTS_ARMOR) {
		AndroidResearchBuilder()
			.setExperienceCost(25)
			.withDescription()
			.addPrerequisite(OverdriveThatMatters.loc(MNames.NANOBOTS))
			.addFeatureResult(OverdriveThatMatters.loc(MNames.NANOBOTS_ARMOR))
			.withIcon(ICON_ARMOR)
			.build()
	}

	val LIMB_OVERCLOCKING: List<AndroidResearchType<*>>
	val NANOBOTS_ARMOR_SPEED: List<AndroidResearchType<*>>
	val NANOBOTS_ARMOR_STRENGTH: List<AndroidResearchType<*>>
	val NANOBOTS_REGENERATION: List<AndroidResearchType<*>>

	init {
		val limbList = ArrayList<RegistryObject<AndroidResearchType<*>>>()
		val regenList = ArrayList<RegistryObject<AndroidResearchType<*>>>()
		val armorStrengthList = ArrayList<RegistryObject<AndroidResearchType<*>>>()
		val armorSpeedList = ArrayList<RegistryObject<AndroidResearchType<*>>>()

		for (i in 0 until 4) {
			limbList.add(registry.register(MNames.LIMB_OVERCLOCKING_LIST[i]) {
				val limbs = AndroidResearchBuilder()
					.setExperienceCost(18 + i * 8)
					.withIconText(TextComponent((i + 1).toString()))
					.withIcon(ICON_LIMB_OVERCLOCKING)
					.withName(TranslatableComponent("android_research.overdrive_that_matters.limb_overclocking", i + 1))
					.withDescription(
						TranslatableComponent(
							"android_research.overdrive_that_matters.limb_overclocking.description",
							(i + 1) * 8,
							(i + 1) * 6
						)
					)
					.addFeatureResult(OverdriveThatMatters.loc(MNames.LIMB_OVERCLOCKING), i)

				if (i > 0) {
					limbs.addPrerequisite(OverdriveThatMatters.loc(MNames.LIMB_OVERCLOCKING_LIST[i - 1]))
				}

				limbs.build()
			})

			regenList.add(registry.register(MNames.NANOBOTS_REGENERATION_LIST[i]) {
				val regeneration = AndroidResearchBuilder()
					.setExperienceCost(20 + i * 6)
					.withIconText(TextComponent((i + 1).toString()))
					.withIcon(ICON_NANOBOTS)
					.withName(TranslatableComponent("android_research.overdrive_that_matters.nanobots_regeneration", i + 1))
					.withDescription(
						if (i > 0) TranslatableComponent("android_research.overdrive_that_matters.nanobots_regeneration.description_improve") else TranslatableComponent(
							"android_research.overdrive_that_matters.nanobots_regeneration.description"
						)
					)
					.addFeatureResult(OverdriveThatMatters.loc(MNames.NANOBOTS_REGENERATION), i)


				if (i > 0) {
					regeneration.addPrerequisite(OverdriveThatMatters.loc(MNames.NANOBOTS_REGENERATION_LIST[i - 1]))
				} else {
					regeneration.addPrerequisite(OverdriveThatMatters.loc(MNames.NANOBOTS))
				}

				regeneration.build()
			})
		}

		for (i in 0 until 3) {
			val level = i + 1

			armorStrengthList.add(registry.register(MNames.NANOBOTS_ARMOR_STRENGTH_LIST[i]) {
				AndroidResearchBuilder()
					.setExperienceCost(20 + i * 8)
					.withIconText(TextComponent((i + 1).toString()))
					.withIcon(ICON_ARMOR)
					.addPrerequisite(OverdriveThatMatters.loc(if (i > 0) MNames.NANOBOTS_ARMOR_STRENGTH_LIST[i - 1] else MNames.NANOBOTS_ARMOR))
					.withName(
						TranslatableComponent(
							"android_research.overdrive_that_matters.nanobots_armor_strength",
							i + 1
						)
					)
					.withDescription(
						TranslatableComponent(
							"android_research.overdrive_that_matters.nanobots_armor_strength.description",
							(i + 1) * 8,
							(i + 1) * 6
						)
					)
					.addFeatureResult(OverdriveThatMatters.loc(MNames.NANOBOTS_ARMOR), 0) { feature ->
						if ((feature as NanobotsArmor).strength < level) feature.strength = level
					}
					.build()
			})

			armorSpeedList.add(registry.register(MNames.NANOBOTS_ARMOR_SPEED_LIST[i]) {
				AndroidResearchBuilder()
					.setExperienceCost(20 + i * 8)
					.withIconText(TextComponent((i + 1).toString()))
					.withIcon(ICON_ARMOR)
					.addPrerequisite(OverdriveThatMatters.loc(if (i > 0) MNames.NANOBOTS_ARMOR_SPEED_LIST[i - 1] else MNames.NANOBOTS_ARMOR))
					.withName(
						TranslatableComponent(
							"android_research.overdrive_that_matters.nanobots_armor_speed",
							i + 1
						)
					)
					.withDescription(
						TranslatableComponent(
							"android_research.overdrive_that_matters.nanobots_armor_speed.description",
							(i + 1) * 8,
							(i + 1) * 6
						)
					)
					.addFeatureResult(OverdriveThatMatters.loc(MNames.NANOBOTS_ARMOR), 0) { feature ->
						if ((feature as NanobotsArmor).speed < level) feature.speed = level
					}
					.build()
			})
		}

		LIMB_OVERCLOCKING = RegistryObjectList(limbList)
		NANOBOTS_REGENERATION = RegistryObjectList(regenList)
		NANOBOTS_ARMOR_SPEED = RegistryObjectList(armorSpeedList)
		NANOBOTS_ARMOR_STRENGTH = RegistryObjectList(armorStrengthList)
	}
}