package ru.dbotthepony.mc.otm.registry

import net.minecraftforge.registries.IForgeRegistryEntry
import net.minecraftforge.registries.RegistryObject

class LazyList<T>(private vararg val getters: () -> T) : AbstractList<T>() {
	override val size: Int
		get() = getters.size

	override fun get(index: Int): T {
		return getters[index].invoke()
	}
}

class RegistryObjectList<T : IForgeRegistryEntry<T>>(private vararg val getters: RegistryObject<T>) : AbstractList<T>() {
	constructor(getters: List<RegistryObject<T>>) : this(*getters.toTypedArray())

	override val size: Int
		get() = getters.size

	override fun get(index: Int): T {
		return getters[index].get()
	}
}
